#include <Arduino.h>
#include <HardwareSerial.h>
#include <avr/pgmspace.h>
const PROGMEM int8_t CIVTestString[] = { static_cast<int8_t>(0xff), 00, static_cast<int8_t>(0xaa), static_cast<int8_t>(0x99) };
static const uint8_t CIVTestMsgLength = 4;
static const uint16_t CIVTestMsgBaudRate = 38400;

bool CIVInterfaceConnectTest(HardwareSerial *a, HardwareSerial * b, const uint8_t * msg)
{
	uint8_t test[4];
	::memset(test,0,CIVTestMsgLength);
	while (b->available())  // clear out buffer
		b->read();
	a->write(msg,CIVTestMsgLength);
	delay(5);
	uint8_t t = 0;
	while (b->available() && t < CIVTestMsgLength)
		test[t++] = b->read();
	while (a->available())  // clear out buffer of what I just sent.
		a->read();
	return (::memcmp(test,msg,CIVTestMsgLength) == 0) ? true : false;
}

void CIVInterfaceTest()
{
	Serial.begin(115200);
	Serial1.begin(CIVTestMsgBaudRate);
	Serial2.begin(CIVTestMsgBaudRate);
	Serial3.begin(CIVTestMsgBaudRate);

	HardwareSerial * s[3] = { &Serial2, &Serial1 , &Serial3 };
	

	uint8_t test[CIVTestMsgLength];
	uint8_t connect[9];
	for (uint8_t i = 0 ; i < CIVTestMsgLength ; ++i)
		test[i] = pgm_read_byte(CIVTestString+i);
	Serial.println(F("CIV Interface Test Program"));
	delay(1000);
	while(true)  // do this forever...
	{
		delay(55);
		while (Serial.available())
			Serial.read();
		::memset(connect,0,9);
		for ( uint8_t j = 0 ; j < 3 ; ++j)
		{
			for ( uint8_t i = 0; i < 3 ; ++i)
			{
				if (i == j)  continue;
				uint8_t index = j*3 + i;
				connect[index] = CIVInterfaceConnectTest(s[j],s[i],test) ? 1 : 0;
			}
		}
		uint8_t sum = 0;
		for (uint8_t i = 0 ; i < 9 ; ++i)
			sum += connect[i];
		if (!sum)
		{
			Serial.println(F("No connection"));
			continue;
		}
		for ( uint8_t j = 0 ; j < 3 ; ++j)
		{
			for ( uint8_t i = 0; i < 3 ; ++i)
			{
				if (i == j)  continue;
				uint8_t index = j*3 + i;
				if (!connect[index])
					continue;
				Serial.print(j+1,DEC);
				Serial.print(F("->"));
				Serial.print(i+1,DEC);
				Serial.print(F("  "));
			}
		}
		Serial.println();
	}

	
}
