#include "IcomManager.h"
#include "IcomSerial.h"
#include "AntennaMap.h"
#include <EEPROM.h>
#include "GetConsoleConfig.h"
#include <avr/wdt.h>
#include "PowerBandMap.h"

const bool bThreePorts = true;

IcomManager icomMgr;
SimpleTimeout st1;  // Use for one second time in loop
byte secCount = 0;  // counts seconds (approximately)
configEEProm ee;
GetConsoleConfig conConfig(&Serial);
extern void CIVInterfaceTest();

void onMessageGlobal( IcomSerial * is)
{
	icomMgr.onMessage(is);
};

void SetAntenna(void) 
{
	byte antenna = indexToAntenna(ee.data[0]);
	outputAntennaExternalDecoding(antenna);
}

void onNewFreq(unsigned long freq, const byte icomID)
{
	ee.data[0] = freqToIndex(freq,ee.data[0]);
	SetAntenna();
	ee.resetTimer();
    PowerBandOnNewFreq(freq);
}


void setup() {                
	pinMode(52,INPUT);
	digitalWrite(52,HIGH);
	if (digitalRead(52) == LOW)
		CIVInterfaceTest();
	ee.read();
	// use pin 53 as the mode pin...  Never returns
	conConfig.getConfig(53);

	icomMgr.setup(baudRateIndexToBaudRate(ee.data[offsetEEPROMData_ComputerBaudRateIndex]),
				baudRateIndexToBaudRate(ee.data[offsetEEPROMData_CIVBaudRateIndex]),
				ee.data[offsetEEPROMData_flags]);
	SetAntenna();
	st1.start(1000);
	// enable the watch dog timer on the IC and set the timeout to 2 Seconds
//	wdt_enable(WDTO_2S);
}


void loop() {
	icomMgr.loop();
	// Every time one goes through the loop,  stroke the watch dog timer
//	wdt_reset();
	if(!icomMgr.getLoopCounter() && st1.isTimedout())
	{
		st1.start(1000);  // reset counter for another second
		secCount++;


		if (secCount & 1)
			ee.isUpdateTime();

	}
}











